#import "SHMovieView.h"

@interface QTMovieContentView: NSView

- (id)movie;

@end


@interface QTMovieContentView (ScreenSaver)

@end

@implementation QTMovieContentView (ScreenSaver)

- (BOOL)acceptsFirstResponder
{
	return YES;
}

- (void)keyUp:(NSEvent *) theEvent
{
}

- (void)moveUp:(id)sender
{
	QTMovie * tMovie;
	
	tMovie=[self movie];
	
	if ([tMovie muted]==NO)
	{
		float tVolume;
		
		tVolume=[tMovie volume];
		
		tVolume=tVolume+0.1;
		
		if (tVolume>2.0)
		{
			tVolume=2.0;
		}
		
		[tMovie setVolume:tVolume];
	}
}

- (void)moveDown:(id)sender
{
	QTMovie * tMovie;
	
	tMovie=[self movie];
	
	if ([tMovie muted]==NO)
	{
		float tVolume;
		
		tVolume=[tMovie volume];
		
		tVolume=tVolume-0.1;
		
		if (tVolume<0)
		{
			tVolume=0;
		}
		
		[tMovie setVolume:tVolume];
	}
}

- (void) keyDown:(NSEvent *) theEvent
{
    NSString * tString;
    unsigned int stringLength;
    unsigned int i;
    unichar tChar;
    QTMovie * tMovie;
	
	tMovie=[self movie];
	
    tString= [theEvent characters];
    
    stringLength=[tString length];
	
    for(i=0;i<stringLength;i++)
    {
        tChar=[tString characterAtIndex:i];
		
		switch(tChar)
        {
            case 'm':
            case 'M':
				[tMovie setMuted:![tMovie muted]];
                return;
            case NSDownArrowFunctionKey:
                if ([tMovie muted]==NO)
                {
                    float tVolume;
                    
                    tVolume=[tMovie volume];
                    
                    tVolume=tVolume-0.1;
                    
                    if (tVolume<0)
                    {
                        tVolume=0;
                    }
                    
                    [tMovie setVolume:tVolume];
                    
                    return;
                }
                break;
            case NSUpArrowFunctionKey:
                if ([tMovie muted]==NO)
                {
                    float tVolume;
                    
                    tVolume=[tMovie volume];
                    
                    tVolume=tVolume+0.1;
                    
                    if (tVolume>2.0)
                    {
                        tVolume=2.0;
                    }
                    
                    [tMovie setVolume:tVolume];
                }
                break;
        }
    }
    
    [super keyDown:theEvent];
}

@end

#pragma mark -

@implementation SHMovieView

- (NSView *)hitTest:(NSPoint)aPoint
{
	return nil;
}

- (BOOL)acceptsFirstResponder
{
	return YES;
}

- (void) setMovie:(QTMovie *) inMovie
{
	if (inMovie!=nil)
	{
		NSSize tSize;
		NSValue * tValue;
		
		tSize=[self bounds].size;
		
		tValue=[NSValue valueWithSize:tSize];
		
		[inMovie setAttribute:tValue forKey:QTMovieCurrentSizeAttribute];
	}
	
	[super setMovie:inMovie];
}

- (void) keyDown:(NSEvent *) theEvent
{
    NSString * tString;
    unsigned int stringLength;
    unsigned int i;
    unichar tChar;
    QTMovie * tMovie;
	
	tMovie=[self movie];
	
    tString= [theEvent characters];
    
    stringLength=[tString length];
	
    for(i=0;i<stringLength;i++)
    {
        tChar=[tString characterAtIndex:i];
		
		switch(tChar)
        {
            case 'm':
            case 'M':
				[tMovie setMuted:![tMovie muted]];
                return;
        }
    }
    
    [super keyDown:theEvent];
}

- (void) keyUp:(NSEvent *) theEvent
{
}

- (void)moveUp:(id)sender
{
	QTMovie * tMovie;
	
	tMovie=[self movie];
	
	if ([tMovie muted]==NO)
	{
		float tVolume;
		
		tVolume=[tMovie volume];
		
		tVolume=tVolume+0.1;
		
		if (tVolume>2.0)
		{
			tVolume=2.0;
		}
		
		[tMovie setVolume:tVolume];
	}
}

- (void)moveDown:(id)sender
{
	QTMovie * tMovie;
	
	tMovie=[self movie];
	
	if ([tMovie muted]==NO)
	{
		float tVolume;
		
		tVolume=[tMovie volume];
		
		tVolume=tVolume-0.1;
		
		if (tVolume<0)
		{
			tVolume=0;
		}
		
		[tMovie setVolume:tVolume];
	}
}

@end
